unit Srv_Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, SvcMgr, Dialogs,
  IdAntiFreezeBase, IdAntiFreeze, IdBaseComponent, IdSocketHandle,IdComponent, IdUDPBase,
  IdUDPServer, ExtCtrls,Winsock,Forms,Inifiles, IdTCPServer,
  IdCustomHTTPServer, IdHTTPServer;

    type
  TProcessorTimeInfo = record
    IdleTime: int64;
    KernelTime: int64;
    UserTime: int64;
    DpcTime: int64;
    InterruptTime:int64;
    InterruptCount:cardinal;
  end;

type
  TLoadBalancerAgentFrm = class(TService)
    Timer1: TTimer;
    UDPServer: TIdUDPServer;
    UDPAntiFreeze: TIdAntiFreeze;
    IdHTTPServer1: TIdHTTPServer;
    procedure UDPServerUDPRead(Sender: TObject; AData: TStream;ABinding: TIdSocketHandle);
    Function  GetAvrgCPU(): Integer;
    procedure ServiceStart(Sender: TService; var Started: Boolean);
    procedure Timer1Timer(Sender: TObject);
    procedure ServiceStop(Sender: TService; var Stopped: Boolean);
    Function  GetCpuLoad(): Integer;
    procedure IdHTTPServer1CommandGet(AThread: TIdPeerThread;
      ARequestInfo: TIdHTTPRequestInfo;
      AResponseInfo: TIdHTTPResponseInfo);
  private
    { Private declarations }
  public
  s1,s2                :int64;
    function GetServiceController: TServiceController; override;

  end;

var
  LoadBalancerAgentFrm   : TLoadBalancerAgentFrm;
  CPULoad             : TStringList;
  //LogFile             : TStringList;
  Logs                : Array[1..100] Of String;
  AvrgCPU             : Integer;
  function NtQuerySystemInformation(si_class: cardinal; si: pointer; si_length: cardinal; ret_length:cardinal):cardinal; stdcall; external 'ntdll.dll';

implementation

{$R *.DFM}

procedure ServiceController(CtrlCode: DWord); stdcall;
begin
  LoadBalancerAgentFrm.Controller(CtrlCode);
end;

function TLoadBalancerAgentFrm.GetServiceController: TServiceController;
begin
  Result := ServiceController;
end;

Function TLoadBalancerAgentFrm.GetCpuLoad(): Integer;
var
  buf:array[0..299999] of char;

  ti                   : ^TProcessorTimeInfo;
  i                    :integer;
begin

  NtQuerySystemInformation(8, @buf, 300000, 0);

  ti:=@buf;
  s2:=ti^.KernelTime+ti^.UserTime{+ti^.DpcTime+ti^.InterruptTime}-ti^.IdleTime;

  i:=round((s2-s1)/100000);
  s1:=s2;

  if (i<=100) and (i>0) then
  begin
      Result:= i;
  end
  else
     Result:= 1;
     
End;



Function TLoadBalancerAgentFrm.GetAvrgCPU(): Integer;
var
k,i                                       : Integer;
l                                         : double;
res                                       : Integer;
begin

  Result:=1;
  k:=0;
  l:=0;

  For i:=0 To 178 Do
  CPULoad.Strings[i]:=CPULoad.Strings[i+1];

  CPULoad.Strings[179]:=InTToStr(GetCPULoad);
  CPULoad.SaveToFile(ExtractFilePath(Application.ExeName)+'CPULoad.bin');

  For i:=0 To 179 Do
  if   CPULoad.Strings[i]<>'-1' Then
  Begin
    l:=l+StrToInt(CPULoad.Strings[i]);
    inc(k);
  End;

  if k>0 Then
    res:=Round(l/k);

  if res<1 Then
    res:=1;

  Result:=res;
  
end;


procedure TLoadBalancerAgentFrm.UDPServerUDPRead(Sender: TObject; AData: TStream;
  ABinding: TIdSocketHandle);
var
  Buffer                                  : Array[0..1] of Cardinal;
  i                                       : Integer;
  TmpWORD                                 : WORD;
begin
  try

    AData.Read(TmpWORD,2);
    Buffer[0] :=   TmpWORD;
    Buffer[1] :=   htons(WORD(AvrgCPU));

    ABinding.SendTo(ABinding.PeerIP, ABinding.PeerPort, Buffer, 6);


    Try
    For i:=1 To 99 Do
    Logs[i]:=logs[i+1];
    Logs[100]:='Packet from  ' + ABinding.PeerIP  + ':' + IntToStr(ABinding.PeerPort)+'<br>'+
    'Target: ' + IntToSTr(htons(TmpWORD)) + ' - Return Value: '+IntToStr(AvrgCPU)+'<br>'+
    DateTimeToStr(now())+'<br>';

    Except
    End;

  finally

  end;
end;

procedure TLoadBalancerAgentFrm.ServiceStart(Sender: TService; var Started: Boolean);
Var i     : Integer;
    CINI  : TIniFile;
begin

  if FileExists(ExtractFilePath(Application.ExeName)+'bngagent.ini') Then
  Begin
    CINI:=TIniFile.Create(ExtractFilePath(Application.ExeName)+'bngagent.ini');
    UDPServer.DefaultPort:=CINI.ReadInteger('Settings','Port',2000);
    IdHTTPServer1.DefaultPort:=CINI.ReadInteger('Settings','httpPort',8088);
  End
  else
  Begin
    UDPServer.DefaultPort:=2000;
    IdHTTPServer1.DefaultPort:=8088;
  End;

  IdHTTPServer1.Active:=True;
  UDPServer.Active:=True;
  Timer1.Enabled:=True;

  CPULoad:=TStringList.Create;

  DeleteFile(ExtractFilePath(Application.ExeName)+'CPULoad.bin');

  For i:=1 To 100 Do
    Logs[i]:='';

  For i:=0 To 179 Do
    CPULoad.Add('-1');


  CPULoad.SaveToFile(ExtractFilePath(Application.ExeName)+'CPULoad.bin');

end;

procedure TLoadBalancerAgentFrm.Timer1Timer(Sender: TObject);
begin

  AvrgCPU:=GetAvrgCPU;

end;

procedure TLoadBalancerAgentFrm.ServiceStop(Sender: TService;
  var Stopped: Boolean);
begin

  DeleteFile(ExtractFilePath(Application.ExeName)+'CPULoad.bin');
  DeleteFile(ExtractFilePath(Application.ExeName)+'log.bin');
  CPULoad.Free;

end;

procedure TLoadBalancerAgentFrm.IdHTTPServer1CommandGet(
  AThread: TIdPeerThread; ARequestInfo: TIdHTTPRequestInfo;
  AResponseInfo: TIdHTTPResponseInfo);
  Var i          : Integer;
      TmpString  : String;
begin

    TmpString:='';
    For i:=100 DownTo 1 Do
    if Logs[i]<>'' Then
    TmpString:=TmpString+Logs[i]+'---------------------------------<br>';
   AResponseInfo.ContentText:=TmpString;

   end;

end.
